// La structure de doublet en langage C
// Pour compiler ce programme liste.c, ouvrez un Terminal Unix et :
// $ gcc liste.c -o liste       <-- compilation avec gcc (ou clang sur Apple)
// $ ./liste                    <-- execution

#include <stdio.h>
#include <stdlib.h>

typedef struct doublet {
  int car;                     // le car est un entier,
  struct doublet *cdr;         // et le cdr contient l'adresse du doublet suivant
} doublet;

typedef doublet *liste;        // une liste d'entiers

liste cons(int x, liste L) {
  liste new = (liste) malloc(sizeof(doublet));
  new->car = x;
  new->cdr = L;
  return new;
}

int car(liste L) {
  return L->car;
}

liste cdr(liste L) {
  return L->cdr;
}

liste reverse(liste L) {
  liste acc = NULL;               // NULL pour la liste vide
  while(L != NULL) {
    acc = cons(car(L),acc);
    L = cdr(L);
  }
  return acc;
}

void afficher(liste L) {
  printf("(");
  while(L != NULL) {
    printf("%d",car(L));
    L = cdr(L);
    if (L != NULL) printf(" ");
  }
  printf(")");
}

liste append (liste L1, liste L2) {             //   (define (append L1 L2)
  if (L1 == NULL) return L2;                    //     (cond ((null? L1) L2)
  return cons (car(L1),append(cdr(L1),L2));     //           (else (cons (car L1) (append (cdr L1) L2)))))
}

int length(liste L) {
  int res = 0;
  for(; L != NULL; res++, L=cdr(L));            // ou while
  return res;
}

int main()  {
  liste L = cons(1, cons(2, cons(3, cons(4, NULL))));
  printf("Voici la liste L : "); afficher(L); printf("\n");
  printf("Elle contient %d elements ", length(L));
  printf("et son inverse au sens de Scheme est : ");
  afficher(reverse(L)); printf("\n");
  printf("Concatenation de L et de reverse(L) : ");
  afficher(append(L,reverse(L))); printf("\n");
  return 0;
}


