#lang racket
;;; Racket 6.6
;;; Fichier d'utilitaires pour les TP d'option PF2

(provide while show)    ; on peut aussi exporter des macros

(define-syntax while    ; (e1 e2 ...) represente une liste ayant au moins un element e1, car (e2 ...) peut etre vide !
  (syntax-rules ()
    ((while test e1 e2 ...) (let ()
                              (define (iter)
                                (if (not test)
                                    (void)
                                    (begin e1 e2 ... (iter))))
                              (iter)))))

; Exemple d'utilisation (cette fonction n'est pas dans la liste du provide)

(define (test-while)
  (let ((x 10) (s 0))
    (while (> x 0)
           (set! s (+ s x))
           (set! x (- x 1)))
    (printf "1 + 2 + 3 + ... + 10 = ~a\n" s)))

; (test-while)

(define-syntax show
  (syntax-rules ()
    ((show expr) (begin (printf "? ~s\n" 'expr) (printf "--> ~s\n" expr)))))

; Exemple d'utilisation :
; (show (sqrt 5))

